//+------------------------------------------------------------------+
//|                                               RSI_Strike(AM).mq4 |
//|                                               Andrey Matvievskiy |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Andrey Matvievskiy"
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Aqua
#property indicator_color3 Silver
#property indicator_color4 Silver
#property indicator_color5 Orange
#property indicator_color6 Orange
#property indicator_color7 Red
#property indicator_color8 Red

//----
double CrossUp1[];
double CrossDown1[];
double CrossUp2[];
double CrossDown2[];
double CrossUp3[];
double CrossDown3[];
double CrossUp4[];
double CrossDown4[];
extern bool alertsOn           = false;
extern bool alertsOnEveryArrow = false;
extern bool alertsOnLevel1     = true;
extern bool alertsOnLevel2     = true;
extern bool alertsOnLevel3     = true;
extern bool alertsOnLevel4     = true;
extern bool alertsOnCurrent    = false;
extern bool alertsMessage      = true;
extern bool alertsSound        = false;
extern bool alertsEmail        = false;


extern int RSI_Period1=2;
extern int RSI_Period2=4;
extern int RSI_Price1=0;
extern int RSI_Price2=0;

extern int RSI_Period3=3;
extern int RSI_Period4=6;
extern int RSI_Price3=0;
extern int RSI_Price4=0;

extern int RSI_Period5=4;
extern int RSI_Period6=8;
extern int RSI_Price5=0;
extern int RSI_Price6=0;

extern int RSI_Period7=5;
extern int RSI_Period8=10;
extern int RSI_Price7=0;
extern int RSI_Price8=0;


extern int CountedBars = 300;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0, CrossUp1);   SetIndexStyle(0, DRAW_ARROW,0,0); SetIndexArrow(0, 233);
   SetIndexBuffer(1, CrossDown1); SetIndexStyle(1, DRAW_ARROW,0,0); SetIndexArrow(1, 234);
   SetIndexBuffer(2, CrossUp2);   SetIndexStyle(2, DRAW_ARROW,0,0); SetIndexArrow(2, 233);
   SetIndexBuffer(3, CrossDown2); SetIndexStyle(3, DRAW_ARROW,0,0); SetIndexArrow(3, 234);
   SetIndexBuffer(4, CrossUp3);   SetIndexStyle(4, DRAW_ARROW,0,0); SetIndexArrow(4, 233);
   SetIndexBuffer(5, CrossDown3); SetIndexStyle(5, DRAW_ARROW,0,0); SetIndexArrow(5, 234);
   SetIndexBuffer(6, CrossUp4);   SetIndexStyle(6, DRAW_ARROW,0,0); SetIndexArrow(6, 233);
   SetIndexBuffer(7, CrossDown4); SetIndexStyle(7, DRAW_ARROW,0,0); SetIndexArrow(7, 234);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

      //
      //
      //
      //
      //
      
     for(int i=0; i<=limit; i++) 
     {
      double Range=0;
        for(int k=0 ;k<=10;k++) Range+=MathAbs(High[i+k]-Low[i+k]);
                                Range/=10;
     
         double A_1 = iRSI(NULL, 0, RSI_Period1, RSI_Price1, i);
         double A_2 = iRSI(NULL, 0, RSI_Period1, RSI_Price1, i+1);
         double B_1 = iRSI(NULL, 0, RSI_Period2, RSI_Price2, i);
         double B_2 = iRSI(NULL, 0, RSI_Period2, RSI_Price2, i+1);
         double C_1 = iRSI(NULL, 0, RSI_Period3, RSI_Price3, i);
         double C_2 = iRSI(NULL, 0, RSI_Period3, RSI_Price3, i+1);
         double D_1 = iRSI(NULL, 0, RSI_Period4, RSI_Price4, i);
         double D_2 = iRSI(NULL, 0, RSI_Period4, RSI_Price4, i+1);
         double E_1 = iRSI(NULL, 0, RSI_Period5, RSI_Price5, i);
         double E_2 = iRSI(NULL, 0, RSI_Period5, RSI_Price5, i+1);
         double F_1 = iRSI(NULL, 0, RSI_Period6, RSI_Price6, i);
         double F_2 = iRSI(NULL, 0, RSI_Period6, RSI_Price6, i+1);
         double G_1 = iRSI(NULL, 0, RSI_Period7, RSI_Price7, i);
         double G_2 = iRSI(NULL, 0, RSI_Period7, RSI_Price7, i+1);
         double K_1 = iRSI(NULL, 0, RSI_Period8, RSI_Price8, i);
         double K_2 = iRSI(NULL, 0, RSI_Period8, RSI_Price8, i+1);

         CrossUp1[i]   = EMPTY_VALUE;
         CrossUp2[i]   = EMPTY_VALUE;
         CrossUp3[i]   = EMPTY_VALUE;
         CrossUp4[i]   = EMPTY_VALUE;
         CrossDown1[i] = EMPTY_VALUE;
         CrossDown2[i] = EMPTY_VALUE;
         CrossDown3[i] = EMPTY_VALUE;
         CrossDown4[i] = EMPTY_VALUE;

       if ((A_1 > B_1) &&(A_2 < B_2))
        {
         CrossUp1[i]=Low[i] - Range*0.2;
        }
        else  if ((A_1 < B_1) &&(A_2 > B_2))
        {
         CrossDown1[i]=High[i] + Range*0.2;
        }
        
        if ((C_1 > D_1) &&(C_2 < D_2))
        {
         CrossUp2[i]=Low[i] - Range*0.4;
        }
        else  if ((C_1 < D_1) &&(C_2 > D_2))
        {
         CrossDown2[i]=High[i] + Range*0.4;
        }
        
        
        if ((E_1 > F_1) &&(E_2 < F_2))
        {
         CrossUp3[i]=Low[i] - Range*0.6;
        }
        else  if ((E_1 < F_1) &&(E_2 > F_2))
        {
         CrossDown3[i]=High[i] + Range*0.6;
        }
              
             
       
        if ((G_1 > K_1) &&(G_2 < K_2))
        {
         CrossUp4[i]=Low[i] - Range*0.8;
        }
        else  if ((G_1 < K_1) &&(G_2 > K_2))
        {
         CrossDown4[i]=High[i] + Range*0.8;
        }
   }
   manageAlerts();
   return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
            
      if (alertsOnLevel1 && (CrossUp1[whichBar]!=EMPTY_VALUE || CrossDown1[whichBar]!=EMPTY_VALUE))
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (!alertsOnEveryArrow) time1 = Time[0];
            if (CrossUp1[whichBar]   != EMPTY_VALUE) doAlert(time1,mess1," rsi strike level 1 signal up");
            if (CrossDown1[whichBar] != EMPTY_VALUE) doAlert(time1,mess1," rsi strike level 1 signal down");
      }
      if (alertsOnLevel2 && (CrossUp2[whichBar]!=EMPTY_VALUE || CrossDown2[whichBar]!=EMPTY_VALUE))
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (!alertsOnEveryArrow) time2 = Time[0];
            if (CrossUp2[whichBar]   != EMPTY_VALUE) doAlert(time2,mess2," rsi strike level 2 signal up");
            if (CrossDown2[whichBar] != EMPTY_VALUE) doAlert(time2,mess2," rsi strike level 2 signal down");
      }
      if (alertsOnLevel3 && (CrossUp3[whichBar]!=EMPTY_VALUE || CrossDown3[whichBar]!=EMPTY_VALUE))
      {
         static datetime time3 = 0;
         static string   mess3 = "";
            if (!alertsOnEveryArrow) time3 = Time[0];
            if (CrossUp3[whichBar]   != EMPTY_VALUE) doAlert(time3,mess3," rsi strike level 3 signal up");
            if (CrossDown3[whichBar] != EMPTY_VALUE) doAlert(time3,mess3," rsi strike level 3 signal down");
      }
      if (alertsOnLevel4 && (CrossUp4[whichBar]!=EMPTY_VALUE || CrossDown4[whichBar]!=EMPTY_VALUE))
      {
         static datetime time4 = 0;
         static string   mess4 = "";
            if (!alertsOnEveryArrow) time4 = Time[0];
            if (CrossUp4[whichBar]   != EMPTY_VALUE) doAlert(time4,mess4," rsi strike level 4 signal up");
            if (CrossDown4[whichBar] != EMPTY_VALUE) doAlert(time4,mess4," rsi strike level 4 signal down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" rsi strike",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

